function aaa =  QRS_SVM_TRAIN(train_data,test_data,kernel, mode_3D, colx, coly)
%  [QRS Width (ms), R_peak (V), Heart Rate (bpm)]

%---------------------------------
%Give training data a label of "1".
%---------------------------------

%--train_data is a n x 4 (first 3 columns are features, 4th is label) 
%matrix that is used for TRAINING and only contains one class (binary classification
%--test_data is a m x 4 matix used for TESTING and contains any class
%--kernel specifies the kernel type
%--mode_3d specifies whether 3 features (==1) or 2 features (==0) are being
%used. If mode_3D == 1, the colx and coly can be any number, since those
%only apply to mode_3D == 0;
%--colx specifies which column (1 or 2) will be used for featureX
%--coly specifices which column (2 or 3) will be used for featureY

QRS_features = train_data;
hannah_test2_features = test_data;
       
input_positive = 0;
input_negative = 0;

truepositive = 0;    
truenegative = 0;
falsepositive = 0;
falsenegative = 0;
positive = 0;
negative = 0;

if (mode_3D == 0)
    figure;
    Sample(:,1) = hannah_test2_features(:,colx);
    Sample(:,2) = hannah_test2_features(:,coly);
    label = hannah_test2_features(:,4);

    data = [QRS_features(:,colx),QRS_features(:,coly)];
    groups = QRS_features(:,4);
    L_groups = length(test_data(:,4));
    for i = 1:L_groups
        if(test_data(i,4))
            input_positive = input_positive +1;
        else
            input_negative = input_negative +1;
        end
    end
        

    svmStruct = svmtrain(data,groups,'Kernel_Function',kernel,'showplot',true);

    y = svmclassify( svmStruct,Sample,'showplot',true);
    
    title(sprintf('Kernel Function: %s',func2str(svmStruct.KernelFunction)),'interpreter','none');

        if (colx == 1 && coly ==2)    
            xlabel('QRS Width (ms)');
            ylabel('R wave Peak (V)');
        elseif (colx == 1 && coly ==3)
            xlabel('QRS Width (ms)');
            ylabel('Local Heart Rate (beats/min)');   
        elseif (colx == 2 && coly ==3)
            xlabel('R wave Peak (V)');
            ylabel('Local Heart Rate (beats/min)');  
        end
        
        for j =1:length(y)
            if(y(j))
            positive = positive +1 ;
            end
            if(y(j) == test_data(j,4))
                if (y(j))
                    truepositive = truepositive +1;
                else
                    truenegative = truenegative + 1;
                end
            else
                if(y(j))
                    falsepositive = falsepositive +1;
                else
                    falsenegative = falsenegative +1;
                end
            end
        end
        
        positive_percent = 100*positive/length(y);
        negative_percent = 100 - positive_percent;
        truepositive_percent = 100*truepositive/length(y);
        truenegative_percent = 100*truenegative/length(y);
        falsepositive_percent = 100*falsepositive/length(y);
        falsenegative_percent = 100*falsenegative/length(y);
        
        like = questdlg(['Positive = ',num2str(positive_percent),'% Negative = ',num2str(negative_percent),'%.' ], ...
        'Zoom','Yes','No','Yes');
        like = questdlg(['True Positive = ',num2str(truepositive_percent),'% True Negative = ',num2str(truenegative_percent),'%.' ], ...
        'Zoom','Yes','No','Yes');   
        like = questdlg(['False Positive = ',num2str(falsepositive_percent),'% False Negative = ',num2str(falsenegative_percent),'%. End?' ], ...
        'Zoom','Yes','No','Yes'); 
    
   

else
    data = QRS_features(:,1:3); % 3 dimentional
    groups = QRS_features(:,4);
    svmStruct = svmtrain(data,groups,'Kernel_Function',kernel','showplot',true);
    y = svmclassify(svmStruct,hannah_test2_features(:,1:3),'showplot',true);
    
    for j =1:length(y)
            if(y(j))
            positive = positive +1 ;
            end
            if(y(j) == test_data(j,4))
                if (y(j))
                    truepositive = truepositive +1;
                else
                    truenegative = truenegative + 1;
                end
            else
                if(y(j))
                    falsepositive = falsepositive +1;
                else
                    falsenegative = falsenegative +1;
                end
            end
        end
 
        positive_percent = 100*positive/length(y);
        negative_percent = 100 - positive_percent;
        truepositive_percent = 100*truepositive/length(y);
        truenegative_percent = 100*truenegative/length(y);
        falsepositive_percent = 100*falsepositive/length(y);
        falsenegative_percent = 100*falsenegative/length(y);
        
        like = questdlg(['Positive = ',num2str(positive_percent),' and Negative = ',num2str(negative_percent),'.' ], ...
        'Zoom','Yes','No','Yes');
        like = questdlg(['True Positive = ',num2str(truepositive_percent),' and True Negative = ',num2str(truenegative_percent),'.' ], ...
        'Zoom','Yes','No','Yes');   
        like = questdlg(['False Positive = ',num2str(falsepositive_percent),' and False Negative = ',num2str(falsenegative_percent),'.' ], ...
        'Zoom','Yes','No','Yes'); 
end
aaa= 1;
% positive_percent
% negative_percent
% truepositive_percent
% truenegative_percent 
% falsepositive_percent 
% falsenegative_percent

Total_beats = length(y)
input_positive
input_negative
output_positive = positive
output_negative = (length(y) - positive)

truepositive
truenegative
falsepositive
falsenegative

percent_error = 100*(falsepositive + falsenegative)/Total_beats

cp = classperf(test_data(:,4),y)
cp.CorrectRate