%QRS Detector VERSION 10.4 - Transformed 10.3 into function

%----------------------------------------------------------------
%                       ASSUMPTIONS
%-no more than 500 heart beats
%-needs >1 minute to stabalize
%----------------------------------------------------------------
function [features1,RR_average1,beat_num]= QRS_detection(ecg,filename,class,Fs)
Ts = 1/Fs;%for Lab View data Fs = 600, for my data Fs = 1000
offset = 0;
starttime = 1 + offset;
endtime =  length(ecg);%6030;%10001 + offset;

%Circular Array
window = 1200; %window must be >= 30 and <= diagnostic_period1
MWI_window =30*Fs/200;%150 for Lab View, 30 for our ECG;
BPF_delay = 19;
HPF_delay = -0;
D_delay = 1;

x = zeros(window,1); %plus one because need an extra spot for next value
count = 0;

LPF = zeros(window,1);

LPF =  zeros(window,1);
HPF = zeros(window,1);
D =  zeros(window,1);
SQUARE =  zeros(window,1);
MWI =  zeros(window,1);
max=0; %needed to find the MAX for the Gain Adjustment procedure
min = 10000; %needed to find the MIN for the Gain Adjustment procedure

diagnosic_period1 = window + 1;%1000; %assume 1000 samples (1000*Ts = 1.66 sec) needed to make estimate of total max MWI possible

ylimit = 5; %this is to make the normalized wave (0<x<1), to be (0<ylimit*x<ylimit)

SPKI = 0; %running esitmate of SIGNAL peak in MWI
NPKI = 10000; %running estimate of NOISE peak in MWI

THR_SIG = 0;
THR_NOISE = 0;

CURRENTPEAK= 0;

FOUND = zeros(window,1);
fid_mark = FOUND;

CURRENTMIN = -100; %used to find the fidicual mark, which is the begining of the QRS complex
CURRENTMIN_pos = 1; %the position of the fiducial mark

PREVIOUSMIN = 100000; %must be initialized to a value not possible for the MWI
PREVIOUSMIN_pos = 1;

CURRENT_R_array = zeros(window,1);
CURRENT_R_array_pos = 1; %the is the molduled position for CURRENT_R_array, using new_D
CURRENT_R = 0; %represents the peak of the R wave
CURRENT_R_pos = 1; %represents the time of the R wave peak (count)

R_found = 0; %this is a boolean variable that tells you if a R wave peak has been found. If MWI>THR_NOISE then R_found = 1, if MWI<THR_NOISE then R_found = 0

N = 8; %this is the number of beats that are averaged together
RR_Nbeats1 = zeros(N,1); %This contains the N most recent sequential RR intervals, for RRaverage1
RR_Nbeats2 = zeros(N,1); %This contains the N most recent sequential RR intervals, for RRaverage2
RR_average1 = 0; %This is the average of RR_8beats
RR_average2 = 0;
RR_MISSED = 0; %This is a limit that is 166% of RR_average2
beat_num = 0; %counts the number of beats that have occured
mod_beat_num_N = 0; %is a temporary variable for the moduled position in RR_Nbeats1 array in the RR interval calculation
avg2_count = 0; %counts the number of times an RR interval falls between RR_HIGH_LIMIT and RR_LOW_LIMIT
RR_LOW_LIMIT = 0; %the LOWER limit for acceptable RR intervals for RR_average2 calculation
RR_HIGH_LIMIT = 0; %the HIGHER limit for acceptable RR intervals for RR_average2 calculation
RR_MISSED_LIMIT = 0; %the MISSED limit for RR intervals for 

found_QRS_end = 0; %This is a boolean variable, where 0 means the QRS end was NOT found, and 1 means it was.
QRS_end_pos = 1; %This represents the position of the end of the QRS wave for the current beat_num
QRS_start_pos = -1; %this represents the start position of the current QRS complex

estimated_session_beats = 500; %this means that in one session of running this program, there can be no more than estimated_session_beats heart beats (ex..if estimated_session_beats=500 and HR = 200 b/min, duration = 2.5 min. if HR = 70 b/min, duration = 7.14 min)
QRS_width_memory = zeros(estimated_session_beats,1); %this contains the QRS width for each heart beat
%for RR_memory, could also just include RR_average1 for every beat, but
%then would have to find the average of N QRS widths.
RR_memory = zeros(estimated_session_beats,1); %this contains the RR interval between the current beat and the next beat. So if looking at RR_memory(2,1), this is the RR from beat 2 to 3
R_peak = zeros(estimated_session_beats,1);

time_thresh = 10; %this variable creates a delay, and decline any peak with in "time_thresh" samples starting from CURRENT_R_pos (for QRS_end_pos)

num_features = 3; %this is the number of features.
% features = zeros(estimated_session_beats,num_features);

QRS_width_low_limit = 80;
QRS_width_high_limit = 200;

RR_low_limit = 40;
RR_high_limit = 200;

R_peak_low_limit = 0.4;

%--------------------------
% For testing and making nice figures
%---------------------------
temp1_count = 1;
% temp1_pos = zeros(window,1);

temp2_count = 1;
% temp2_pos = zeros(window,1);

temp3_count = 1;

temp4_count = 0; %for counting how many times RR_Nbeats1 > RR_MISSED_LIMIT

temp5_count = 1; %for ecg version on FOUND



%--------------------------
%---------------------------


    %simulates ADC operation
    for i=starttime:endtime%1555%length(ecg) %in real time, it keeps going
        % AGC
        new_x = mod(count,window) + 1;     
       
        if (i==(window*2 +1))      
            
                tt = 1:window;
                   figure;
                   subplot(2,2,2)
        

                hold on
                plot(tt/Fs,500*x,'m');
                plot(tt/Fs,500*BPF);
                stem(new_D/Fs,x(new_D,1),'filled','b')
                title([filename, ' Moving Window Integrator'])
                plot((1:length(MWI))/Fs,THR_SIG, 'r');
                plot((1:length(MWI))/Fs,THR_NOISE,'r');
                plot(tt/Fs,MWI,'k');
                hold off
                xlim([0 window/Fs]);

                % This plots everything with no lines (used in poster)
                

               subplot(2,2,1)
                hold on
                plot(tt/Fs,x,'m');
                plot(tt/Fs,BPF);
                hold off
                title([filename,' ECG Before Analysis']);
                xlabel('Time (s)');
                xlim([0 window/Fs]);


                subplot(2,2,3)
                hold on
                plot(tt/Fs,x,'m');
                plot(tt/Fs,BPF);
                stem(temp2_pos/Fs,temp2_value,'filled','k');
                stem(temp5_pos/Fs,temp5_value,'filled','g');
                stem(temp1_pos/Fs,temp1_value,'filled','r');
                hold off
                title([filename,' ECG After Analysis']);
                xlabel('Time (s)');
                xlim([0 window/Fs]);
                
        end
%         if (ecg(i,1)>=max)
%            max = ecg(i,1);
%         end
%         x(new_x,1) = ylimit*ecg(i,1)/max;
%         
%         if (x(new_x,1)<=min)
%            min= x(new_x,1);
%         end
%         x(new_x,1) = x(new_x,1)-min;
        
        x(new_x,1) = ecg(i,1);
      
        
        %makes sure that before any processing happens, that the array is
        %full of input values so that filter can take place
        if (count>=32)%window-1)
            
            
                %---------------------------------------------------------
                % HIGH PASS FILTER and shift
                %---------------------------------------------------------
                new_HPF = delayer(HPF_delay,new_x,window);
                HPF(new_x,1) = (32*x(delayer(16,new_x,window),1) - HPF(delayer(1,new_HPF,window),1) - x(new_x,1) + x(delayer(32,new_x,window),1))/(32*36);
                
                %---------------------------------------------------------
                % LOW PASS FILTER and shift
                %---------------------------------------------------------
                new_LPF = delayer(BPF_delay,new_x,window);
                LPF(new_LPF,1) = ((2*LPF(delayer(1,new_LPF,window),1) - LPF(delayer(2,new_LPF,window),1) + HPF(new_x,1) - 2*HPF(delayer(6,new_x,window),1) + HPF(delayer(12,new_x,window),1)));

                BPF = LPF;
                
                %---------------------------------------------------------
                % DIFFERENTIATION (Backwards) and shift
                %---------------------------------------------------------
                new_D = delayer(D_delay,new_LPF,window);
                 D(new_D,1) = (BPF(new_LPF,1) - BPF(delayer(1,new_LPF,window),1))*(1/Ts);
               
               

                %---------------------------------------------------------
                % NON-LINEAR TRANSFORMATION: SQUARING 
                %---------------------------------------------------------
                SQUARE(new_D,1) = D(new_D,1)^2;

                %---------------------------------------------------------
                % Moving Window Integrator (MWI)
                %---------------------------------------------------------
                MWI(new_D,1)=0;
              for k=0:(MWI_window-1)
                  delay = mod((   new_D  -1)-k,window) + 1;
                  MWI(new_D,1) = MWI(new_D,1) + (1/MWI_window)*(SQUARE(delayer(k,new_D,window),1));
              end
              
              
                %---------------------------------------------------------
                % MWI DIFFERENTIATION (Backwards) and shift included
                %---------------------------------------------------------
              MWI_D = (MWI(new_D,1) - MWI(delayer(1,new_D,window),1))*(Fs);
              

              
              
              
              
              
              
            %--------------------------------------------------------------
            %This the code for adjusting the threshold values. The purpose
            %of the diagnostic period is to allow the program to find an
            %approximate maximum of the MWI, which is then used to first
            %initialize SPKI and NPKI. After the diagnostic period is over,
            %the program works by finding peaks and comparing them to the
            %current set thresholds. The thresholds adapt to the changing
            %signal.
            %--------------------------------------------------------------
              
              if (count<diagnosic_period1  && MWI(new_D,1)>= SPKI) %1000 is the diagnostic period need to find approx max value of MWI
                  %this is just my initialization/estimate to the noise and
                  %signal vlaues
                  SPKI =  MWI(new_D,1); %SPKI use to = max_MWI
                  NPKI = SPKI/8;              
                 
                  THR_SIG = NPKI + 0.25*(SPKI-NPKI);
                  THR_NOISE = 0.5*THR_SIG;
               
              elseif (count>diagnosic_period1)      %Now adjust thresholds to changing ECG. Works for the rest of the operating time.
                  if (MWI_D >=0 && MWI(new_D,1) >= CURRENTPEAK)
                      CURRENTPEAK = MWI(new_D,1);
                      FOUND(new_D,1) = 0;
                      
                  elseif (MWI_D < 0 && CURRENTPEAK > 0 )
                      
                      if (found_QRS_end == 0 && CURRENTPEAK > THR_SIG && new_D > mod(CURRENT_R_array_pos + time_thresh,window))
                          
                                SPKI = 0.125*CURRENTPEAK + 0.875*SPKI;
                                FOUND(new_D,1) = x(new_D,1);%CURRENTPEAK;
                                QRS_end_pos = count;
                                
                                found_QRS_end = 1;
                                
                           %only for show. Delete freely
                                temp5_pos(temp5_count,1) = new_D;
                                temp5_value(temp5_count,1) = x(new_D,1);
                                temp5_count = temp5_count +1 ;                               
                             
                        
                        
                        
                               
                      elseif (CURRENTPEAK > THR_NOISE && CURRENTPEAK < THR_SIG)
                          NPKI = 0.125*CURRENTPEAK + 0.875*NPKI;
%                           FOUND(new_D,1) = CURRENTPEAK;
                               



                      elseif (CURRENTPEAK < THR_NOISE)
                          FOUND(new_D,1) = 0;
                      end
                      THR_SIG = NPKI + 0.25*(SPKI - NPKI);
                      THR_NOISE = 0.5*THR_SIG;
                      
                      CURRENTPEAK = 0; %reset currentpeak so that can find a new peak, even if lower than previous                 
                  end                  
                  
                
                  
                  
%This is for finding the beginning of the QRS                
                 %---------------------------------------------------------
                 % This is the Code for finding the first local minima of
                 % successivly increasing local minima, right before MWI
                 % crosses the THR_NOISE mark
                 %Problem: Instead finds the begining of the P wave, and
                 %some times results in false positives for the detection
                 %of the begining of the Q wave. 
                 %Points: -the very last local minima before THR_NOISE is
                 %the peak of the Q wave
                 %---------------------------------------------------------
%                   if (MWI(new_D,1) <= THR_NOISE && MWI_D <=0)
%                       CURRENTMIN = MWI(new_D,1);
%                       CURRENTMIN_pos = new_D;
%                       
%                   elseif (MWI(new_D,1) <= THR_NOISE && CURRENTMIN > -1 && MWI_D >0) %Short circuit, used first condition so that program doesnt have to constantly enter if statment and do same variable assignments over and over
%                       if (CURRENTMIN < PREVIOUSMIN)
%                             PREVIOUSMIN = CURRENTMIN;
%                             PREVIOUSMIN_pos = CURRENTMIN_pos;
%                             CURRENTMIN = -1; %1000000;
%                             CURRENTMIN_pos = 1;   
%                             max_successive_minima = 0;
%                       elseif (CURRENTMIN >= PREVIOUSMIN && CURRENTMIN >= max_successive_minima)
%                           max_successive_minima = CURRENTMIN;
%                       end                
%                       
%                   elseif (MWI(new_D,1) >= THR_NOISE)
%                       fid_mark(PREVIOUSMIN_pos,1) = 1.5; %PREVIOUSTMIN
%                       CURRENTMIN = -1; %1000000;
%                       CURRENTMIN_pos = 1;
%                       PREVIOUSMIN = 100000;
%                       PREVIOUSMIN_pos = 1;
%                       max_successive_minima = 0;
%                   end





                 %---------------------------------------------------------
                 %This Code finds the very last local minima on MWI, before 
                 %THR_NOISE. The position of the local minima represents 
                 %the peak of the Q wave.
                 %Problem: The begining of the QRS is located at the
                 %begining of the Q wave and not at the peak of the Q wave
                 %---------------------------------------------------------
                    if (MWI(new_D,1) <= THR_NOISE && MWI_D <=0)
                        QRS_width = 1000*(QRS_end_pos - QRS_start_pos)/Fs ;
                        if ( found_QRS_end == 1)
                            QRS_width_memory(beat_num,1) =  QRS_width;
                      end
                        
                        CURRENTMIN = MWI(new_D,1);
                        CURRENTMIN_pos = new_D;
                        QRS_start_pos = count;
                        
                        
                        
%                         CURRENT_R_array(CURRENT_R_pos,1) = CURRENT_R; 
                        CURRENT_R = 0;
                        R_found = 0;
                        found_QRS_end = 0;
                      
                        
                    elseif(MWI(new_D,1) > THR_NOISE)%&& CURRENTMIN > -1)
%                         fid_mark(CURRENTMIN_pos,1) = BPF(CURRENTMIN_pos,1);%CURRENTMIN; %1000; 
%                        
% if(R_found ==0)    
                        fid_mark(CURRENTMIN_pos,1) = BPF(CURRENTMIN_pos,1);%CURRENTMIN; %1000; 
%                         end
                        %only for show. Delete freely
                        temp1_pos(temp1_count,1) = CURRENTMIN_pos;
                        temp1_value(temp1_count,1) = x(CURRENTMIN_pos,1);
                        temp1_count = temp1_count +1 ;                       
                       
                       
                        %The following code finds the R wave peak and the
                        %position of it.
                       
                        
                        if (x(new_D,1) >= CURRENT_R && D(new_D,1) >= 0 )%&& R_found == 0) %the purpose of D_crossed_zero is to make sure that the search for the R-peak is done between the time when MWI(new_D,1) > THR_SIG and when the derivative of the filtered waveform becomes negative, so that it doesnt search for a long time = not much delay in "beeps"
%                             %this if statement is so that there is no
%                             %overlapping with previous results
%                             if (R_found == 1)
%                                 CURRENT_R_array(CURRENT_R_pos,1) = 0;
%                             end
                            
                            CURRENT_R = x(new_D,1);
                            CURRENT_R_array_pos = new_D;
                            CURRENT_R_pos = count;
                            
                        else
                            CURRENT_R_array(CURRENT_R_array_pos,1) = CURRENT_R-x(CURRENTMIN_pos,1);
                            
                        
                            
                            
                            %For testing purposes, delete freely
                            temp2_pos(temp2_count,1) = CURRENT_R_array_pos;
                            temp2_value(temp2_count,1) = CURRENT_R;
                            temp2_count = temp2_count + 1;                            
                            
                            %this is a short ciruciting if statement. When
                            %a peak is detected, the second if statement is
                            %called, therefore R_found == 1. As a result,
                            %the procedure below (the one out of this if
                            %statement block), will calculate the RR
                            %interval. On the second reoccurance of the if
                            %statement below, the first condiition is met,
                            %and as a result R_found = 2. On future
                            %iteration of this if statement, R_found = 2
                            %until, MWI < THR_NOISE, which then resets
                            %R_found to 0.
                            if (R_found == 1)
                                R_found = 2; %This assingment is so that R_found > 0, so that a peak does not need to be searched for anylonger, untill, MWI falls below THR_NOISE, in which case R_found resets to 0.
                            
                            elseif (R_found == 0 ) %first_peak is for the first R_wave so that the slope is initialized                          
                                    R_found = 1;                                    
                            end                       
                        end
                
%                       end                       

                        CURRENTMIN = -1;
%                         CURRENTMIN_pos = 1;
                    end
                        
%                  %---------------------------------------------------------
%                  %This code find the RR interval and the associated
%                  %averages for the N most recent RR intervals (window
%                  %moves one beat at a time). This was done, so that the
%                  information could be processed in real time. Otherwise,
%                  it could have been put in the big if statement above.
%                  %---------------------------------------------------------

                    %Design problem: dont know if should use a N-sized
                    %window that moves by one heart beat, or that moves by
                    %N heart beats for the averaging. The latter would mean
                    %that every N beats, the array is dumped and new one is
                    %started. This could mean reduced processing time for
                    %SVM classification, or possibly too little data.
                    
                    if (R_found ==1)
                        if (beat_num > N+1) %taking an average of N RR intervals, by default, N = 8.
                            RR = CURRENT_R_pos - PREV_R_pos;
                            
                                mod_beat_num_N = mod(beat_num,N)+1;
                                RR_Nbeats1(mod_beat_num_N,1) = RR; %array containing the N most recent RR intervals
    %                             RR_memory(beat_num,1) = CURRENT_R_pos - PREV_R_pos;
                                    RR_memory(beat_num + 1,1) = RR;
                                    R_peak(beat_num +1,1) = CURRENT_R;

                                %this calculates the RR low and high limits
                                %based on the current value of RR_average2
                                RR_LOW_LIMIT = 0.92*RR_average2;
                                RR_HIGH_LIMIT = 1.16*RR_average2;
                                RR_MISSED_LIMIT = 1.66*RR_average2;

                                if (RR_Nbeats1(mod_beat_num_N,1) >= RR_LOW_LIMIT && RR_Nbeats1(mod_beat_num_N,1) <= RR_HIGH_LIMIT && RR_Nbeats1(mod_beat_num_N,1) <= RR_MISSED_LIMIT )
                                    RR_Nbeats2(mod(avg2_count,N)+1,1) = RR_Nbeats1(mod_beat_num_N,1);

                                    avg2_count = avg2_count +1;


                                    if (avg2_count >= N)
                                        RR_average2 = 0;
                                        for z = 1:N
                                            RR_average2 = RR_average2 + RR_Nbeats2(z,1)/N;
                                        end
                                    end
    %                                 avg2_count = avg2_count +1;

                                %If this if statement is called, then that
                                %means a heart beat has been missed, since the
                                %current RR interval cannot change faster than
                                %166% of the previous one (physiological
                                %contraint). This then initiates a searchback
                                %procedure where 
                                elseif (RR_Nbeats1(mod_beat_num_N,1) > RR_MISSED_LIMIT)
                                    temp4_count = temp4_count + 1;
                                end

                                RR_average1 = 0;
                                for z = 1:N
                                    RR_average1 = RR_average1 + RR_Nbeats1(z,1)/N;
                                end
                                PREV_R_pos = CURRENT_R_pos;
                            
                            
                            
                        elseif (beat_num == N+1)  %whole purpose of this if statement is so that RR_average2 can be initialized (happens once)                  
                            RR = CURRENT_R_pos - PREV_R_pos;              
                                                 
                                        RR_Nbeats1(mod(beat_num,N)+1,1) = RR; %array containing the N most recent RR intervals
            %                             RR_memory(beat_num,1) = CURRENT_R_pos - PREV_R_pos;
                                            RR_memory(beat_num + 1,1) = RR;
                                            R_peak(beat_num +1,1) = CURRENT_R;

                                        RR_average1 = 0;
                                        for z = 1:N
                                            RR_average1 = RR_average1 + RR_Nbeats1(z,1)/N;
                                        end
                                        PREV_R_pos = CURRENT_R_pos;

                                        RR_average2 = RR_average1; %assumes that after 9 successsful heart beats (8 RR intervals), the averages are the same.

                            
                        elseif (beat_num > 0) % this gets short-circuited by the above condition, thus this allows the array to fill up before being able to calculate RR_average1
                            RR = CURRENT_R_pos - PREV_R_pos;
                            
                             
                                        RR_Nbeats1(mod(beat_num,N)+1,1) = RR;
            %                             RR_memory(beat_num,1) = CURRENT_R_pos - PREV_R_pos;
                                            RR_memory(beat_num + 1,1) = RR;
                                            R_peak(beat_num +1,1) = CURRENT_R;

                                        PREV_R_pos = CURRENT_R_pos;
                            
                        
                        else                           
                            PREV_R_pos = CURRENT_R_pos; %need to initialize time of first beat
                        end
                        
                       
                            beat_num = beat_num + 1;
                       
                    end            
              end             
        end
        
        count = count +1;
    end
  
% figure;
% hold on
% plot(x,'c');
% plot(BPF,'b')
% % stem(FOUND/1000,'filled','g');
% stem(temp1_pos,temp1_value,'filled','m','LineWidth',2);
% %plot(MWI,'k');
% %plot(1:length(MWI),THR_SIG, 'k');
% %plot(1:length(MWI),THR_NOISE,'k');
% stem(temp2_pos,temp2_value,'filled','r','LineWidth',2);
% plot(D,'m');
% 
% hold off
% 
% 
% % figure;
% % hold on
% % plot(MWI,'k');
% % stem(200*fid_mark,'filled','m');
% % stem(200*CURRENT_R_array,'filled','r');
% % plot(1:length(MWI),THR_SIG, 'k');
% % plot(1:length(MWI),THR_NOISE,'k');
% % plot(D,'b');
% % hold off
% % 
% figure;
% hold on
% plot(0.01*MWI,'k');
% plot(x,'c');
% plot(BPF);
% stem(fid_mark,'filled','m');
% stem(CURRENT_R_array,'filled','r');
% plot(1:length(MWI),0.01*THR_SIG, 'k');
% plot(1:length(MWI),0.01*THR_NOISE,'k');
% stem(0.001*FOUND,'filled','g');
% stem(new_D,x(new_D,1),'filled','b')
% stem(new_x,x(new_x,1),'filled','y')
% plot(0.01*D,'m');
% hold off
% 
% 
% figure
% 
% hold on
% plot(1:length(MWI),THR_SIG, 'k');
% plot(1:length(MWI),THR_NOISE,'k');
% plot(MWI,'k');
% stem(NPKI)
% stem(SPKI)
% stem(FOUND,'filled','g');
% plot(D,'m')
% stem(new_D,1000*x(new_D,1),'filled','b')
% stem(new_x,1000*x(new_x,1),'filled','y')
% plot(500*x,'b');
% plot(500*BPF,'r');
% hold off
% 





% figure
% 
% hold on
% plot(x,'c');
% plot(BPF);
% stem(new_D,x(new_D,1),'filled','b')
% stem(CURRENT_R_array,'filled','r');
% stem(FOUND,'filled','g');
% stem(fid_mark,'filled','m');
% title('hannah test1 Fs200')
% plot(1:length(MWI),THR_SIG/1000, 'k');
% plot(1:length(MWI),THR_NOISE/1000,'k');
% plot(MWI/1000,'k');
% hold off
% 
% % This plots everything with no lines (used in poster)
% tt = 1:window;
% 
% figure;
% hold on
% plot(tt/Fs,x,'m');
% plot(tt/Fs,BPF);
% hold off
% % xlim([19.5 22.5]);
%  
% 
% figure;
% hold on
% plot(tt/Fs,x,'m');
% plot(tt/Fs,BPF);
% stem(temp2_pos/Fs,temp2_value,'filled','k');
% stem(temp5_pos/Fs,temp5_value,'filled','g');
% stem(temp1_pos/Fs,temp1_value,'filled','r');
% hold off
% xlim([19.5 22.5]);
% xlim([3900 4500]);




% figure
% 
% hold on
% plot(saved_x,'c');
% plot(saved_BPF);
% stem(saved_new_D,x(saved_new_D,1),'filled','b')
% stem(saved_CURRENT_R_array,'filled','r');
% stem(saved_FOUND,'filled','g');
% stem(saved_fid_mark,'filled','m');
% title('hannah test1 Fs200')
% plot(1:length(MWI),THR_SIG/1000, 'k');
% plot(1:length(MWI),THR_NOISE/1000,'k');
% plot(saved_MWI/1000,'k');
% hold off
% 
% % This plots everything with no lines (used in poster)
% 
% 
% figure;
% hold on
% plot(saved_x,'m');
% plot(saved_BPF);
% hold off
% % xlim([19.5 22.5]);
%  
% 
% figure;
% hold on
% plot(saved_x,'m');
% plot(saved_BPF);
% stem(saved_temp2_pos/Fs,saved_temp2_value,'filled','k');
% stem(saved_temp5_pos/Fs,saved_temp5_value,'filled','g');
% stem(saved_temp1_pos/Fs,saved_temp1_value,'filled','r');
% hold off


count = 1;
for a = 1:length(QRS_width_memory)
    if(QRS_width_memory(a,1) > QRS_width_low_limit && R_peak(a,1) >0.2 && QRS_width_memory(a,1) < QRS_width_high_limit && RR_memory(a,1) > RR_low_limit && RR_memory(a,1) < RR_high_limit)
        features1(count,1) = QRS_width_memory(a,1);
        features1(count,2) = R_peak(a,1);
        features1(count,3) = ((RR_memory(a,1)/Fs)^-1)*60;
        features1(count,4) = class;
        count = count +1;
    end
end
RR_average1 = sum(features1(:,3))/length(features1(:,3));
subplot(2,2,4)
plot3k(features1(:,1:3));
title(['Feature Values for ',filename]);
xlabel('QRS Width (ms)');
ylabel('R Wave Peak (V)');
zlabel('Heart Rate (beats/min)');
RR_average1

% likeROI = questdlg('Continue with classification?', ...
%                             'Zoom','Yes','No','Yes');

% likeROI=input('Continue with classification?  ','s');


%       linear  Default. Linear kernel or dot product.
%       quadratic  Quadratic kernel.
%       rbf  Gaussian Radial Basis Function kernel with a default scaling factor, sigma, of 1.
%       polynomial  Polynomial kernel with a default order of 3.
%       mlp  Multilayer Perceptron kernel with default scale and bias parameters of [1, -1].
%       @functionname  Handle to a kernel function specified using @and the functionname. For example, @kfun, or an anonymous function.

% QRS_SVM_TRAIN(train_data,test_data,kernel, mode_3D, colx, coly)
% % % % % % % % % % % % % % load RobFinal2_features;
% % % % % % % % % % % % % % done = QRS_SVM_TRAIN(features,RobFinal2_features,'rbf', 0, 1, 2);






%
%Things to do
%-Turn original code into function so that can input ecg data easier
%-take out QRS_SVM_TRAIN
%-put all of it in one

































